#Quick and dirty to fix problem caused by Doxygen version 1.6.3 and mscgen tool version 0.17 mismatch for handling msc's
#Author: pyle@kotikone.fi
#

#Used Modules
use File::Spec;
use File::Basename;
use strict;
use Getopt::Std;
use Cwd;

my $ver = "v0.1";
my $arguments = "";
my %arguments = ();
my $file;
my $rivi = "";
my $basefolder = getcwd;
my $folder = "";
my @files_array;

sub syntax()
{
  print "\n***********************************************************************";
  print "\n*   MSCFIX script $ver                                                *";
  print "\n*                                                                     *";
  print "\n*   Quick and dirty to fix problem caused by Doxygen version 1.6.3    *";
  print "\n*   and mscgen tool version 0.17 mismatch for handling msc's           *";
  print "\n*   This script does not necessarily fix all the problems!             *";
  print "\n*   In this case either fix xxx.msc manually or enhance this script!   *";
  print "\n***********************************************************************\n";
  exit 1;
}

#**********************************************************************************
# Argument handling
getopts( "f:", \%arguments );

if ( $arguments{f} )
{
  $basefolder = $arguments{f};
}
else
{
  print "current folder: $basefolder\n";
}

# First HTML documentation...
$folder = $basefolder . "/html";
if ( -e $folder)  #if folder exists it is used
{
  chdir "$folder"; # change working dir
  opendir (DIR, "$folder") or die "Read folder failed!\n";
  @files_array = grep { /.*\.msc/i } readdir(DIR);

  foreach(@files_array)
  {
    $file = $_;
    next if /.bak/;    # skip backup files
    print "handling $file\n";
    open (FILE, "$folder\\$file") or die "Can't open file $folder\\$file!\n";
    open (WRITE, ">temp_$file") or die "Can't write to file temp_$file!\n";
    while(<FILE>)
    {
      $rivi = $_;
      # Erroneous data generated by doxygen   a- b [ label = "ab()" ] ;
      # Corrected format should be            a->b [ label = "ab()" ] ;
      # and more
      # A>>B [label="return"];
      # A<<B [label="return"];
      # A=>>B [label="call-back"];
      # A<<=B [label="call-back", URL="www.google.com"];
      # correction fix empty space to > (from the beginning of the string only

      if( s/^\s*\S+(-\s{1})\S+.*/$1/)
		  {
        $rivi =~ s/$1/->/g;
      }

      if( s/^\s*\S+(\s{1}-)\S+.*/$1/)
		  {
        $rivi =~ s/$1/<-/g;
      }
      if( s/^\s*\S+(=\s{1})\S+.*/$1/)
		  {
        $rivi =~ s/$1/=>/;  # no g allowed due to other usage of = mark
      }

      if( s/^\s*\S+(\s{1}=)\S+.*/$1/)
		  {
        $rivi =~ s/$1/<=/;  # no g allowed due to other usage of = mark
      }

      if( s/^\S+(=\s{2})\S+.*/$1/)
		  {
        $rivi =~ s/$1/=>>/;  # no g allowed as only first str replace beginning...
      }
      if( s/^\S+(\s{2}=)\S+.*/$1/)
		  {
        $rivi =~ s/$1/<<=/;  # no g allowed as only first str replace beginning...
      }
      # subset only conditionally, i.e two spaces to >> only when not companied with =
      if( s/^\S+(\s{2})\S+.*/$1/)
		  {
        $rivi =~ s/$1/>>/;  # no g allowed as only first str replace beginning...NOW FIXED...ORDER >> THIS MIGHT CAUSE ERRONEOUS PICTURES!!!
        print "\nNOTE mscfix script can not determine DIRECTION of the desired ARROW! CHECK AND FIX THIS MANUALLY!!!\n";
      }

      $rivi =~ s/--->/---/g;  # Fix erroneous replacement in second round if .msc already fixed...BEST SOLUTION IS TO CLEAR html and rtf and start beginning!

      print WRITE $rivi;
    }
    close (FILE);
    close (WRITE);
    unlink( "$file" );
    rename "temp_$file", "$file";

    #Generate png from msc
    system "mscgen -T png -i $file";
  }
}

# Then RTF documentation...
$folder = $basefolder . "/rtf";
if ( -e $folder)  #if folder exists it is used
{
  chdir "$folder"; # change working dir
  opendir (DIR, "$folder") or die "Read folder failed!\n";
  @files_array = grep { /.*\.msc/i } readdir(DIR);

  foreach(@files_array)
  {
    $file = $_;
    next if /.bak/;    # skip backup files
    print "handling $file\n";
    open (FILE, "$folder\\$file") or die "Can't open file $folder\\$file!\n";
    open (WRITE, ">temp_$file") or die "Can't write to file temp_$file!\n";
    while(<FILE>)
    {
      $rivi = $_;
      # Erroneous data generated by doxygen   a- b [ label = "ab()" ] ;
      # Corrected format should be            a->b [ label = "ab()" ] ;
      if( s/^\s*\S+(-\s{1})\S+.*/$1/)
		  {
        $rivi =~ s/$1/->/g;
      }

      if( s/^\s*\S+(\s{1}-)\S+.*/$1/)
		  {
        $rivi =~ s/$1/<-/g;
      }
      if( s/^\s*\S+(=\s{1})\S+.*/$1/)
		  {
        $rivi =~ s/$1/=>/;  # no g allowed due to other usage of = mark
      }

      if( s/^\s*\S+(\s{1}=)\S+.*/$1/)
		  {
        $rivi =~ s/$1/<=/;  # no g allowed due to other usage of = mark
      }
      if( s/^\S+(=\s{2})\S+.*/$1/)
		  {
        $rivi =~ s/$1/=>>/;  # no g allowed as only first str replace beginning...
      }
      if( s/^\S+(\s{2}=)\S+.*/$1/)
		  {
        $rivi =~ s/$1/<<=/;  # no g allowed as only first str replace beginning...
      }
      # subset only conditionally, i.e two spaces to >> only when not companied with =
      if( s/^\S+(\s{2})\S+.*/$1/)
		  {
        $rivi =~ s/$1/>>/;  # no g allowed as only first str replace beginning...NOW FIXED...ORDER >> THIS MIGHT CAUSE ERRONEOUS PICTURES!!!
        print "\nNOTE mscfix script can not determine DIRECTION of the desired ARROW! CHECK AND FIX THIS MANUALLY!!!\n";
      }

      $rivi =~ s/--->/---/g;  # Fix erroneous replacement in second round if .msc already fixed

      print WRITE $rivi;
    }
    close (FILE);
    close (WRITE);
    unlink( "$file" );
    rename "temp_$file", "$file";

    #Generate png from msc
    system "mscgen -T png -i $file";
  }
}

exit 0;
